Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip_igmp.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip_igmp.h	(revision 331)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip_igmp.h	(revision 331)
@@ -0,0 +1,184 @@
+/*
+ *  TINET (TCP/IP Protocol Stack)
+ *
+ *  Copyright (C) 2001-2012 by Dep. of Computer Science and Engineering
+ *                   Tomakomai National College of Technology, JAPAN
+ *
+ *  ãLì ÒÍCÈºÌ (1)`(4) Ìð©CFree Software Foundation
+ *  ÉæÁÄö\³êÄ¢é GNU General Public License Ì Version 2 ÉL
+ *  q³êÄ¢éðð½·êÉÀèC{\tgEFAi{\tgEFA
+ *  ðüÏµ½àÌðÜÞDÈº¯¶jðgpE¡»EüÏEÄzziÈºC
+ *  pÆÄÔj·é±Æð³Åø·éD
+ *  (1) {\tgEFAð\[XR[hÌ`Åp·éêÉÍCãLÌì
+ *       \¦C±Ìpð¨æÑºLÌ³ÛØKèªC»ÌÜÜÌ`Å\[
+ *      XR[hÉÜÜêÄ¢é±ÆD
+ *  (2) {\tgEFAðCCu`®ÈÇC¼Ì\tgEFAJ­Ég
+ *      pÅ«é`ÅÄzz·éêÉÍCÄzzÉº¤hL
+gip
+ *      Ò}j
+AÈÇjÉCãLÌì \¦C±Ìpð¨æÑºL
+ *      Ì³ÛØKèðfÚ·é±ÆD
+ *  (3) {\tgEFAðC@íÉgÝÞÈÇC¼Ì\tgEFAJ­Ég
+ *      pÅ«È¢`ÅÄzz·éêÉÍCÌðð½·±ÆD
+ *    (a) ÄzzÉº¤hL
+gipÒ}j
+AÈÇjÉCãLÌ
+ *        ì \¦C±Ìpð¨æÑºLÌ³ÛØKèðfÚ·é±ÆD
+ *  (4) {\tgEFAÌpÉæè¼ÚIÜ½ÍÔÚIÉ¶¶é¢©Èé¹
+ *      Q©çàCãLì Ò¨æÑTOPPERSvWFNgðÆÓ·é±ÆD
+ *
+ *  {\tgEFAÍC³ÛØÅñ³êÄ¢éàÌÅ éDãLì Ò¨
+ *  æÑTOPPERSvWFNgÍC{\tgEFAÉÖµÄC»ÌKpÂ\«à
+ *  ÜßÄC¢©ÈéÛØàsíÈ¢DÜ½C{\tgEFAÌpÉæè¼
+ *  ÚIÜ½ÍÔÚIÉ¶¶½¢©Èé¹QÉÖµÄàC»ÌÓCðíÈ¢D
+ *
+ *  @(#) $Id$
+ */
+
+#ifndef _IP_IGMP_H_
+#define _IP_IGMP_H_
+
+#define NUM_IGMP_ENTRY				5	/* }`LXgO[vÌGg */
+
+#ifdef __CA850__
+#pragma pack(1)
+#elif __RX
+#pragma pack
+#elif _MSC_VER
+#pragma pack(push, 1)
+#endif
+
+ /*
+  *  IGMPv1 wb_Ìè`ARFC 1112
+  */
+
+typedef struct t_igmpv1_hdr
+{
+	uint8_t		type;		/* bZ[WÌ^	*/
+	uint8_t		unused;		/* ¢gp			*/
+	uint16_t	sum;		/* `FbNT		*/
+	T_IN4_ADDR	addr;		/* O[vAhX */
+} T_IGMPV1_HDR;
+
+/*
+*  IGMPv2 wb_Ìè`ARFC 2236
+*/
+
+typedef struct t_igmpv2_hdr
+{
+	uint8_t		type;		/* bZ[WÌ^	*/
+	uint8_t		time;		/* ÅåÔ		*/
+	uint16_t	sum;		/* `FbNT		*/
+	T_IN4_ADDR	addr;		/* O[vAhX */
+} T_IGMPV2_HDR;
+
+typedef struct t_igmpv3_query_hdr
+{
+	uint8_t		type;		/* bZ[WÌ^	*/
+	uint8_t		time;		/* ÅåÔ		*/
+	uint16_t	sum;		/* `FbNT		*/
+	T_IN4_ADDR	grpaddr;	/* O[vAhX */
+	uint8_t		sqrv;		/* StOAQuerier Robustness Value */
+	uint8_t		qqic;		/* Qurier's Query Interval Code */
+	uint16_t	num;		/* M³Ì */
+	T_IN4_ADDR	sdraddr;	/* M³AhX */
+} T_IGMPV3Q_HDR;
+
+typedef struct t_igmp_group_record
+{
+	uint8_t		type;		/* bZ[WÌ^	*/
+	uint8_t		len;		/* âf[^·		*/
+	uint16_t	num;		/* M³Ì */
+	T_IN4_ADDR	grpaddr;	/* O[vAhX */
+	T_IN4_ADDR	sdraddr;	/* M³AhX	*/
+							/* âf[^		*/
+} T_IGMP_GROUP_RECORD;
+
+typedef struct t_igmpv3_report_hdr
+{
+	uint8_t		type;		/* bZ[WÌ^	*/
+	uint8_t		rsv1;		/* \ñ				*/
+	uint16_t	sum;		/* `FbNT		*/
+	uint16_t	rsv2;		/* \ñ				*/
+	uint16_t	num;		/* O[vR[hÌ */
+	T_IGMP_GROUP_RECORD record;	/* O[vR[h */
+} T_IGMPV3R_HDR;
+
+#ifdef __CA850__
+#pragma pack(8)
+#elif __RX
+#pragma unpack
+#elif _MSC_VER
+#pragma pack(pop)
+#endif
+
+#define IGMP_HDR_SIZE			(sizeof(T_IGMPV1_HDR))
+#define IP4_IGMP_HDR_SIZE		(IP4_HDR_SIZE + IGMP_HDR_SIZE)
+#define IF_IP4_IGMP_HDR_SIZE		(IF_IP4_HDR_SIZE + IGMP_HDR_SIZE)
+#define IF_IP4_IGMP_HDR_OFFSET		(IF_IP4_HDR_SIZE)
+
+#define GET_IGMPV1_HDR(nbuf,ihoff)	((T_IGMPV1_HDR*)((uint8_t*)((nbuf)->buf) + ihoff))
+#define GET_IGMPV2_HDR(nbuf,ihoff)	((T_IGMPV2_HDR*)((uint8_t*)((nbuf)->buf) + ihoff))
+#define GET_IGMPV3Q_HDR(nbuf,ihoff)	((T_IGMPV3Q_HDR*)((uint8_t*)((nbuf)->buf) + ihoff))
+#define GET_IGMPV3R_HDR(nbuf,ihoff)	((T_IGMPV3R_HDR*)((uint8_t*)((nbuf)->buf) + ihoff))
+#define GET_IGMP_SDU(nbuf,ihoff)	((uint8_t*)((nbuf)->buf) + ihoff + IGMP_HDR_SIZE)
+
+/*
+*  bZ[WÌ^
+*/
+
+#define IGMP_MEMBERSHIP_QUERY		0x11	/* o[VbvNG[		*/
+#define IGMP_MEMBERSHIP_REPORT		0x12	/* o[Vbv|[g		*/
+#define IGMP_MEMBERSHIP_REPORT_V2	0x16	/* o[Vbv|[g		*/
+#define IGMP_LEAVE_GROUP			0x17	/* [uO[v				*/
+#define IGMP_MEMBERSHIP_REPORT_V3	0x22	/* o[Vbv|[g		*/
+
+/*
+*  UDPÊM[_IvV
+*/
+
+typedef struct ip_mreq
+{
+	T_IN4_ADDR imr_multiaddr; /* IP multicast address of group */
+	T_IN4_ADDR imr_interface; /* local IP address of interface */
+} T_IP_MREQ;
+
+typedef struct ip_msfilter
+{
+	T_IN4_ADDR imsf_multiaddr;     /* IP multicast group address */
+	T_IN4_ADDR imsf_interface;     /* IP address of local interface */
+	uint32_t   imsf_fmode;         /* Filter-mode */
+	uint32_t   imsf_numsrc;        /* Number of sources in the following array */
+	T_IN4_ADDR imsf_slist[1];      /* Array of source addresses */
+} T_IP_MSFILTER;
+
+#define MCAST_INCLUDE     1
+#define MCAST_EXCLUDE     2
+
+extern ER igmp_set_loop(T_UDP_CEP *cep, uint8_t optval);
+extern ER igmp_get_loop(T_UDP_CEP *cep, uint8_t *optval);
+extern ER igmp_set_ttl(T_UDP_CEP *cep, uint8_t optval);
+extern ER igmp_get_ttl(T_UDP_CEP *cep, uint8_t *optval);
+extern ER igmp_set_if(T_UDP_CEP *cep, T_IN4_ADDR *optval);
+extern ER igmp_get_if(T_UDP_CEP *cep, T_IN4_ADDR *optval);
+extern ER igmp_add_membership(T_UDP_CEP *cep, T_IP_MREQ *optval);
+extern ER igmp_drop_membership(T_UDP_CEP *cep, T_IP_MREQ *optval);
+extern ER igmp_set_ip_msfilter(T_UDP_CEP *cep, const T_IP_MSFILTER *optval);
+extern ER igmp_get_ip_msfilter(T_UDP_CEP *cep, T_IP_MSFILTER *optval);
+
+/*
+ *  IGMP O[vGg
+ */
+
+typedef struct igmp_entry
+{
+	uint16_t	timer;		/* MÜÅÌÔ[b]	*/
+	uint16_t	resptime;	/* ÅåÔ[b]	*/
+	T_IN4_ADDR	ip_addr;	/* IP AhX			*/
+} T_IGMP_ENTRY;
+
+extern void igmp_init(void);
+extern bool_t igmp_is_joined_group(T_IN4_ADDR addr);
+extern uint_t igmp_input(T_NET_BUF **inputp, uint_t *offp, uint_t *nextp);
+
+#endif	/* of #ifndef _IP_IGMP_H_ */
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip_input.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip_input.c	(revision 321)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip_input.c	(revision 331)
@@ -2,5 +2,5 @@
  *  TINET (TCP/IP Protocol Stack)
  * 
- *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
+ *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
  *                   Tomakomai National College of Technology, JAPAN
  *
@@ -77,4 +77,5 @@
 #include <t_syslog.h>
 #include "kernel_cfg.h"
+#include "tinet_cfg.h"
 
 #endif	/* of #ifdef TARGET_KERNEL_ASP */
@@ -85,4 +86,5 @@
 #include <t_services.h>
 #include "kernel_id.h"
+#include "tinet_id.h"
 
 #endif	/* of #ifdef TARGET_KERNEL_JSP */
@@ -97,4 +99,5 @@
 #include <net/ppp_ipcp.h>
 #include <net/net.h>
+#include <net/net_endian.h>
 #include <net/net_buf.h>
 #include <net/net_count.h>
@@ -107,8 +110,8 @@
 #include <netinet/ip_icmp.h>
 #include <netinet/tcp.h>
-#include <netinet/tcp_timer.h>
 #include <netinet/tcp_var.h>
 #include <netinet/udp.h>
 #include <netinet/udp_var.h>
+#include <netinet/ip_igmp.h>
 
 #if defined(SUPPORT_IPSEC)
@@ -122,4 +125,6 @@
 
 #include <net/if_var.h>
+
+#if defined(_IP4_CFG)
 
 /*
@@ -345,14 +350,16 @@
 ip_remove_options (T_NET_BUF *nbuf)
 {
-	T_IP_HDR	*iph;
-
-	iph  = GET_IP_HDR(nbuf);
-
-	if (GET_IP_HDR_SIZE(iph) > IP4_HDR_SIZE) {
-		memmove((char *)iph + IP4_HDR_SIZE, GET_IP_SDU(nbuf),
-		        (size_t)(iph->len - GET_IP_HDR_SIZE(iph)));
+	T_IP4_HDR	*iph;
+	uint_t		hdr_size;
+
+	iph  = GET_IP4_HDR(nbuf);
+	hdr_size = GET_IP4_HDR_SIZE(nbuf);
+
+	if (hdr_size > IP4_HDR_SIZE) {
+		memmove((char *)iph + IP4_HDR_SIZE, GET_IP4_SDU(nbuf),
+		        (size_t)(iph->len - hdr_size));
 		iph->vhl   = IP4_MAKE_VHL(IPV4_VERSION, IP4_HDR_SIZE >> 2);
-		iph->len  -= (uint16_t)(GET_IP_HDR_SIZE(iph) - IP4_HDR_SIZE);
-		nbuf->len -= (uint16_t)(GET_IP_HDR_SIZE(iph) - IP4_HDR_SIZE);
+		iph->len  -= (uint16_t)(hdr_size - IP4_HDR_SIZE);
+		nbuf->len -= (uint16_t)(hdr_size - IP4_HDR_SIZE);
 		}
 
@@ -389,6 +396,6 @@
 		}
 
-	ip4h  = GET_IP4_HDR(input);
-	hlen = GET_IP4_HDR_SIZE(ip4h);
+	ip4h = GET_IP4_HDR(input);
+	hlen = GET_IP4_HDR_SIZE(input);
 
 	/* バージョンをチェックする。*/
@@ -429,5 +436,5 @@
 	/* 送信元アドレスをチェックする。*/
 	src = ntohl(ip4h->src);
-	bc  = (ifp->in_ifaddr.addr & ifp->in_ifaddr.mask) | ~ifp->in_ifaddr.mask;
+	bc  = (ifp->in4_ifaddr.addr & ifp->in4_ifaddr.mask) | ~ifp->in4_ifaddr.mask;
 
 #ifdef SUPPORT_LOOP
@@ -441,5 +448,5 @@
 #else	/* of #ifdef SUPPORT_LOOP */
 
-	if (src == ifp->in_ifaddr.addr || src == bc || src == IPV4_ADDR_BROADCAST || src == IPV4_ADDRANY) {
+	if (src == ifp->in4_ifaddr.addr || src == bc || src == IPV4_ADDR_BROADCAST || src == IPV4_ADDRANY) {
 		NET_COUNT_IP4(net_count_ip4[NC_IP4_IN_ERR_ADDR], 1);
 		NET_COUNT_MIB(ip_stats.ipInAddrErrors, 1);
@@ -459,16 +466,27 @@
 	 */
 
-	if ((ifp->in_ifaddr.addr != IPV4_ADDRANY) &&
-	    (!(dst == ifp->in_ifaddr.addr || dst == bc ||
-	       dst == IPV4_ADDR_BROADCAST || dst == IPV4_ADDRANY))) {
+#if defined(ETHER_CFG_MULTICAST)
+	if ((ifp->in4_ifaddr.addr != IPV4_ADDRANY) &&
+		(!(dst == ifp->in4_ifaddr.addr || dst == bc ||
+		   dst == IPV4_ADDR_BROADCAST  || dst == IPV4_ADDRANY ||
+		  IN4_IS_ADDR_MULTICAST(dst)))) {
 		NET_COUNT_IP4(net_count_ip4[NC_IP4_IN_ERR_ADDR], 1);
 		NET_COUNT_MIB(ip_stats.ipInAddrErrors, 1);
 		goto buf_rel;
 		}
+#else
+	if ((ifp->in4_ifaddr.addr != IPV4_ADDRANY) &&
+	    (!(dst == ifp->in4_ifaddr.addr || dst == bc ||
+	       dst == IPV4_ADDR_BROADCAST  || dst == IPV4_ADDRANY))) {
+		NET_COUNT_IP4(net_count_ip4[NC_IP4_IN_ERR_ADDR], 1);
+		NET_COUNT_MIB(ip_stats.ipInAddrErrors, 1);
+		goto buf_rel;
+		}
+#endif
 
 #else	/* of #ifdef DHCP_CFG */
 
 #if defined(ETHER_CFG_MULTICAST)
-	if (!(dst == ifp->in_ifaddr.addr || dst == bc ||
+	if (!(dst == ifp->in4_ifaddr.addr || dst == bc ||
 		  dst == IPV4_ADDR_BROADCAST || dst == IPV4_ADDRANY ||
 		  IN4_IS_ADDR_MULTICAST(dst))) {
@@ -478,6 +496,6 @@
 		}
 #else
-	if (!(dst == ifp->in_ifaddr.addr || dst == bc ||
-	      dst == IPV4_ADDR_BROADCAST || dst == IPV4_ADDRANY)) {
+	if (!(dst == ifp->in4_ifaddr.addr || dst == bc ||
+	      dst == IPV4_ADDR_BROADCAST  || dst == IPV4_ADDRANY)) {
 		NET_COUNT_IP4(net_count_ip4[NC_IP4_IN_ERR_ADDR], 1);
 		NET_COUNT_MIB(ip_stats.ipInAddrErrors, 1);
@@ -525,13 +543,5 @@
 	switch (ip4h->proto) {
 
-#ifdef SUPPORT_UDP
-	case IPPROTO_UDP:
-		NET_COUNT_MIB(ip_stats.ipInDelivers, 1);
-		udp_input(&input, &off, NULL);
-		return;
-		break;
-#endif	/* of #ifdef SUPPORT_UDP */
-
-#ifdef SUPPORT_TCP
+#if defined(SUPPORT_TCP)
 	case IPPROTO_TCP:
 		NET_COUNT_MIB(ip_stats.ipInDelivers, 1);
@@ -539,5 +549,14 @@
 		return;
 		break;
-#endif	/* of #ifdef SUPPORT_UDP */
+#endif	/* of #if defined(SUPPORT_TCP) */
+
+#if defined(SUPPORT_UDP) && ( (TNUM_UDP4_CEPID > 0) || \
+                             ((TNUM_UDP6_CEPID > 0) && defined(API_CFG_IP4MAPPED_ADDR)))
+	case IPPROTO_UDP:
+		NET_COUNT_MIB(ip_stats.ipInDelivers, 1);
+		udp4_input(&input, &off, NULL);
+		return;
+		break;
+#endif	/* of #if defined(SUPPORT_UDP) && TNUM_UDP4_CEPID > 0 */
 
 	case IPPROTO_ICMP:
@@ -546,4 +565,12 @@
 		return;
 		break;
+
+#if defined(SUPPORT_IGMP)
+	case IPPROTO_IGMP:
+		NET_COUNT_MIB(ip_stats.ipInDelivers, 1);
+		igmp_input(&input, &off, NULL);
+		return;
+		break;
+#endif /* of #ifdef UDP_CFG_EXTENTIONS */
 
 #if defined(SUPPORT_IPSEC)
@@ -560,5 +587,5 @@
 
 		/* ローカル IP アドレスに届いたデータグラムのみ ICMP エラーを通知する。*/
-		if (dst == ifp->in_ifaddr.addr) {
+		if (dst == ifp->in4_ifaddr.addr) {
 			T_IN4_ADDR	src;
 
@@ -578,2 +605,4 @@
 	syscall(rel_net_buf(input));
 	}
+
+#endif	/* of #if defined(_IP4_CFG) */
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip_output.c
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip_output.c	(revision 321)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip_output.c	(revision 331)
@@ -2,5 +2,5 @@
  *  TINET (TCP/IP Protocol Stack)
  * 
- *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
+ *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
  *                   Tomakomai National College of Technology, JAPAN
  *
@@ -93,4 +93,5 @@
 #include <net/ppp.h>
 #include <net/net.h>
+#include <net/net_endian.h>
 #include <net/net_buf.h>
 #include <net/net_count.h>
@@ -104,4 +105,6 @@
 #include <netinet6/ipsec.h>
 #endif
+
+#if defined(_IP4_CFG)
 
 static uint16_t frag_id = 0;
@@ -221,5 +224,5 @@
 
 		len  = ntohs(ip4h->len);
-		off  = hlen = GET_IP4_HDR_SIZE(ip4h);
+		off  = hlen = GET_IP4_HDR_SIZE(output);
 		while (off < len) {
 			if (off + (IF_MTU - IP4_HDR_SIZE) < len)
@@ -245,5 +248,5 @@
 				fip4h->id	= htons(frag_id);
 				fip4h->sum	= 0;
-				fip4h->sum	= in_cksum(fip4h, GET_IP4_HDR_SIZE(fip4h));
+				fip4h->sum	= in_cksum(fip4h, GET_IP4_HDR_SIZE(frag));
 
 				NET_COUNT_IP4(net_count_ip4[NC_IP4_OUT_OCTETS], ntohs(fip4h->len));
@@ -279,5 +282,5 @@
 		frag_id ++;
 		ip4h->sum = 0;
-		ip4h->sum = in_cksum(ip4h, GET_IP4_HDR_SIZE(ip4h));
+		ip4h->sum = in_cksum(ip4h, GET_IP4_HDR_SIZE(output));
 
 		NET_COUNT_IP4(net_count_ip4[NC_IP4_OUT_OCTETS], ntohs(ip4h->len));
@@ -301,5 +304,5 @@
 	frag_id ++;
 	ip4h->sum = 0;
-	ip4h->sum = in_cksum(ip4h, (uint_t)GET_IP4_HDR_SIZE(ip4h));
+	ip4h->sum = in_cksum(ip4h, (uint_t)GET_IP4_HDR_SIZE(output));
 
 	NET_COUNT_IP4(net_count_ip4[NC_IP4_OUT_OCTETS], ntohs(ip4h->len));
@@ -327,2 +330,4 @@
 	return error;
 	}
+
+#endif	/* of #if defined(_IP4_CFG) */
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip_var.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip_var.h	(revision 321)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/ip_var.h	(revision 331)
@@ -2,5 +2,5 @@
  *  TINET (TCP/IP Protocol Stack)
  * 
- *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
+ *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
  *                   Tomakomai National College of Technology, JAPAN
  *
@@ -71,18 +71,6 @@
 #define _IP_VAR_H_
 
-/*
- *  IPv4 ヘッダ・ペイロードアクセスマクロ
- */
-
-#define IF_IP4_HDR_SIZE			(IF_HDR_SIZE + IP4_HDR_SIZE)
-
-#define GET_IP4_HDR(nbuf)		((T_IP4_HDR*)((nbuf)->buf + IF_HDR_SIZE))
-#define GET_IP4_SDU(nbuf)		((uint8_t*)((nbuf)->buf) + GET_IF_IP4_HDR_SIZE(nbuf))
-
-#define GET_IP4_HDR_SIZE(iph)		((uint8_t)IP4_VHL_HL((iph)->vhl) << 2)
-#define GET_IP4_SDU_SIZE(iph)		(ntohs((iph)->len) - GET_IP4_HDR_SIZE(iph))
-#define GET_IF_IP4_HDR_SIZE(nbuf)	(IF_HDR_SIZE + (GET_IP4_HDR_SIZE(GET_IP4_HDR(nbuf))))
-
-#define SET_IP4_SDU_SIZE(iph,slen)	((iph)->len=(uint16_t)htons((slen) + IP4_HDR_SIZE))
+#include <netinet/ip4_var.h>
+#include <netinet6/ip6_var.h>
 
 /*
@@ -90,190 +78,78 @@
  */
 
-#if defined(SUPPORT_INET4)
+#define GET_IP_VER(nbuf)		(*(uint8_t*)((nbuf)->buf+IF_HDR_SIZE)>>4)
 
-#define T_TCP_IP_Q_HDR			T_TCP_IP4_Q_HDR
+#if defined(_IP6_CFG)
 
-#define IF_IP_HDR_SIZE			IF_IP4_HDR_SIZE
+#if defined(_IP4_CFG)
+
+#define IF_IP_HDR_SIZE(nbuf)		(GET_IP_VER(nbuf)==IPV6_VERSION?IF_IP6_HDR_SIZE:IF_IP4_HDR_SIZE)
+#define IF_IP_NET_HDR_SIZE(addr)	(IN6_IS_ADDR_V4MAPPED(addr)?IF_IP4_HDR_SIZE:IF_IP6_HDR_SIZE)
+
+#define IP_OUTPUT(nbuf,tmout)		(GET_IP_VER(nbuf)==IPV6_VERSION?ip6_output(nbuf,0,tmout):ip_output(nbuf,tmout))
+#define IP_REMOVE_OPTIONS(nbuf)		(GET_IP_VER(nbuf)==IPV6_VERSION?ip6_remove_exthdrs(nbuf):ip_remove_options(nbuf))
+
+#define GET_IP_HDR(nbuf)		(GET_IP_VER(nbuf)==IPV6_VERSION?GET_IP6_HDR(nbuf):GET_IP4_HDR(nbuf))
+#define GET_IP_HDR_SIZE(nbuf)		(GET_IP_VER(nbuf)==IPV6_VERSION?GET_IP6_HDR_SIZE(nbuf):GET_IP4_HDR_SIZE(nbuf))
+#define GET_IP_SDU_SIZE(nbuf)		(GET_IP_VER(nbuf)==IPV6_VERSION?GET_IP6_SDU_SIZE(nbuf):GET_IP4_SDU_SIZE(nbuf))
+#define GET_IF_IP_HDR_SIZE(nbuf)	(GET_IP_VER(nbuf)==IPV6_VERSION?GET_IF_IP6_HDR_SIZE(nbuf):GET_IF_IP4_HDR_SIZE(nbuf))
+#define GET_IP_TCP_Q_HDR_OFFSET(nbuf)	(GET_IP_VER(nbuf)==IPV6_VERSION?\
+					((T_IP6_TCP_Q_HDR*)GET_IP6_HDR(nbuf))->thoff:((T_IP4_TCP_Q_HDR*)GET_IP4_HDR(nbuf))->thoff)
+
+#define SET_IP_CF(nbuf,cf)		(GET_IP_VER(nbuf)==IPV6_VERSION?SET_IP6_CF(nbuf,cf):(0))
+#define SET_IP_SDU_SIZE(nbuf,len)	(GET_IP_VER(nbuf)==IPV6_VERSION?SET_IP6_SDU_SIZE(nbuf,len):SET_IP4_SDU_SIZE(nbuf,len))
+#define SET_IP_TCP_Q_HDR_OFFSET(nbuf,thoff)	\
+					(GET_IP_VER(nbuf)==IPV6_VERSION\
+						?(((T_IP6_TCP_Q_HDR*)GET_IP6_HDR(nbuf))->thoff=thoff)\
+						:(((T_IP4_TCP_Q_HDR*)GET_IP4_HDR(nbuf))->thoff=thoff))
+
+#else	/* of #if defined(_IP4_CFG) */
+
+#define IF_IP_HDR_SIZE(nbuf)		IF_IP6_HDR_SIZE
+#define IF_IP_NET_HDR_SIZE(addr)	IF_IP6_HDR_SIZE
+
+#define IP_OUTPUT(nbuf,tmout)		ip6_output(nbuf,0,tmout)
+#define IP_REMOVE_OPTIONS(nbuf)		ip6_remove_exthdrs(nbuf)
+
+#define GET_IP_HDR(nbuf)		GET_IP6_HDR(nbuf)
+#define GET_IP_HDR_SIZE(nbuf)		GET_IP6_HDR_SIZE(nbuf)
+#define GET_IP_SDU_SIZE(nbuf)		GET_IP6_SDU_SIZE(nbuf)
+#define GET_IF_IP_HDR_SIZE(nbuf)	GET_IF_IP6_HDR_SIZE(nbuf)
+#define GET_IP_TCP_Q_HDR_OFFSET(nbuf)	(((T_IP6_TCP_Q_HDR*)GET_IP6_HDR(nbuf))->thoff)
+
+#define SET_IP_CF(nbuf,cf)		SET_IP6_CF(nbuf,cf)
+#define SET_IP_SDU_SIZE(nbuf,len)	SET_IP6_SDU_SIZE(nbuf,len)
+#define SET_IP_TCP_Q_HDR_OFFSET(nbuf,thoff)	\
+					(((T_IP6_TCP_Q_HDR*)GET_IP6_HDR(nbuf))->thoff=thoff)
+
+#endif	/* of #if defined(_IP4_CFG) */
+
+#else	/* of #if defined(_IP6_CFG) */
+
+#if defined(_IP4_CFG)
+
+#define IF_IP_HDR_SIZE(nbuf)		IF_IP4_HDR_SIZE
+#define IF_IP_NET_HDR_SIZE(addr)	IF_IP4_HDR_SIZE
+
+#define IP_OUTPUT(nbuf,tmout)		ip_output(nbuf,tmout)
+#define IP_REMOVE_OPTIONS(nbuf)		ip_remove_options(nbuf)
 
 #define GET_IP_HDR(nbuf)		GET_IP4_HDR(nbuf)
-#define GET_IP_SDU(nbuf)		GET_IP4_SDU(nbuf)
+#define GET_IP_HDR_SIZE(nbuf)		GET_IP4_HDR_SIZE(nbuf)
+#define GET_IP_SDU_SIZE(nbuf)		GET_IP4_SDU_SIZE(nbuf)
+#define GET_IF_IP_HDR_SIZE(nbuf)	GET_IF_IP4_HDR_SIZE(nbuf)
+#define GET_IP_TCP_Q_HDR_OFFSET(nbuf)	(((T_IP4_TCP_Q_HDR*)GET_IP4_HDR(nbuf))->thoff)
 
-#define GET_IP_HDR_SIZE(iph)		GET_IP4_HDR_SIZE(iph)
-#define GET_IP_SDU_SIZE(iph)		GET_IP4_SDU_SIZE(iph)
-#define GET_IF_IP_HDR_SIZE(nbuf)	GET_IF_IP4_HDR_SIZE(nbuf)
+#define SET_IP_SDU_SIZE(nbuf,len)	SET_IP4_SDU_SIZE(nbuf,len)
+#define SET_IP_TCP_Q_HDR_OFFSET(nbuf,thoff)	\
+					(((T_IP4_TCP_Q_HDR*)GET_IP4_HDR(nbuf))->thoff=thoff)
 
-#define SET_IP_SDU_SIZE(iph,len)	SET_IP4_SDU_SIZE(iph,len)
+#else	/* of #if defined(_IP4_CFG) */
 
-#define IP_OUTPUT(nbuf,tmout)		ip_output(nbuf,tmout)
-#define IP_INIT()			ip_init()
-#define IP_REMOVE_OPTIONS(nbuf)		ip_remove_options(nbuf)
+#error "not implemented."
 
-#endif	/* of #if defined(SUPPORT_INET4) */
+#endif	/* of #if defined(_IP4_CFG) */
 
-/*
- *  IP の MSS サイズのネットワークバッファ
- */
-
-typedef struct t_net_buf_ip_mss {
-	uint16_t	len;	/* データの長さ		*/
-	uint8_t		idix;	/* mpfid のインデックス	*/
-	uint8_t		flags;	/* フラグ		*/
-#ifdef IF_ETHER_NIC_NET_BUF_ALIGN
-	uint8_t		nalign[IF_ETHER_NIC_NET_BUF_ALIGN];
-#endif
-#if CPU_NET_ALIGN == 4 && IF_HDR_ALIGN != 4
-	uint8_t		halign[4 - IF_HDR_ALIGN];
-#endif
-	uint8_t		buf[IF_HDR_SIZE + IP4_MSS];
-				/* バッファ本体		*/
-	} T_NET_BUF_IP_MSS;
-
-/*
- *  65536 オクテットサイズのネットワークバッファ
- */
-
-typedef struct t_net_buf4_65536 {
-	uint16_t	len;	/* データの長さ		*/
-	uint8_t		idix;	/* mpfid のインデックス	*/
-	uint8_t		flags;	/* フラグ		*/
-#ifdef IF_ETHER_NIC_NET_BUF_ALIGN
-	uint8_t		nalign[IF_ETHER_NIC_NET_BUF_ALIGN];
-#endif
-#if CPU_NET_ALIGN == 4 && IF_HDR_ALIGN != 4
-	uint8_t		halign[4 - IF_HDR_ALIGN];
-#endif
-	uint8_t		buf[IF_IP4_HDR_SIZE + 65536];
-				/* バッファ本体		*/
-#if defined(IF_PDU_HDR_PADDING)
-	uint8_t		padding[IF_PDU_HDR_PADDING];
-#endif				/* ヘッダの余分		*/
-	} T_NET_BUF4_65536;
-
-#ifdef IP4_CFG_FRAGMENT
-
-/*
- *  再構成キュー用 IPv4 ヘッダの定義
- */
-
-typedef struct t_qip4_hdr {
-	uint8_t		vhl;		/* version << 4 | header length >> 2	*/
-					/* length は 4 octets 単位		*/
-	uint8_t		type;		/* type of services			*/
-	uint16_t	len;		/* total length				*/
-
-	uint16_t	id;		/* identification			*/
-	uint16_t	flg_off;	/* fragment flag & offset		*/
-
-	uint8_t		ttl;		/* time to live				*/
-	uint8_t		proto;		/* protocol				*/
-	uint16_t	sum;		/* checksum				*/
-
-	uint32_t	src;		/* source address			*/
-
-	T_NET_BUF	*next;		/* 次の IPv4 フラグメント			*/
-	} __attribute__((packed, aligned(2)))T_QIP4_HDR;
-
-#define QIP4_HDR_SIZE			(sizeof(T_QIP4_HDR))
-#define IF_QIP4_HDR_SIZE		(IF_HDR_SIZE + QIP4_HDR_SIZE)
-
-#define GET_QIP4_HDR(nbuf)		((T_QIP4_HDR*)((nbuf)->buf + IF_HDR_SIZE))
-#define GET_QIP4_SDU(nbuf)		((uint8_t*)(nbuf)->buf + GET_IF_QIP4_HDR_SIZE(nbuf))
-
-#define GET_QIP4_HDR_SIZE(iph)		((uint8_t)IP4_VHL_HL((iph)->vhl) << 2)
-#define GET_IF_QIP4_HDR_SIZE(nbuf)	(IF_HDR_SIZE + (GET_QIP4_HDR_SIZE(GET_QIP4_HDR(nbuf))))
-
-/*
- *  データグラム再構成用ネットワークバッファ
- */
-
-typedef struct t_net_buf4_reassm {
-	uint16_t	len;	/* データの長さ		*/
-	uint8_t		idix;	/* mpfid のインデックス	*/
-	uint8_t		flags;	/* フラグ		*/
-#ifdef IF_ETHER_NIC_NET_BUF_ALIGN
-	uint8_t		nalign[IF_ETHER_NIC_NET_BUF_ALIGN];
-#endif
-#if CPU_NET_ALIGN == 4 && IF_HDR_ALIGN != 4
-	uint8_t		align[4 - IF_HDR_ALIGN];
-#endif
-	uint8_t		buf[IP4_CFG_FRAG_REASSM_SIZE];
-				/* バッファ本体		*/
-	} T_NET_BUF4_REASSM;
-
-#endif	/* of #ifdef IP4_CFG_FRAGMENT */
-
-/*
- *  TCP の再構成キューにおける IPv4 ヘッダの定義
- */
-
-typedef struct t_tcp_ip4_q_hdr {
-	uint8_t		vhl;		/* version << 4 | header length >> 2	*/
-					/* length は 4 octets 単位		*/
-	uint8_t		type;		/* type of services			*/
-	uint16_t	len;		/* total length				*/
-
-	uint16_t	id;		/* identification			*/
-	uint16_t	flg_off;	/* fragment flag & offset		*/
-
-	uint8_t		ttl;		/* time to live				*/
-	uint8_t		proto;		/* protocol				*/
-	uint16_t	thoff;		/* TCP ヘッダのオフセット		*/
-
-	T_IN4_ADDR	src;		/* source address			*/
-	T_IN4_ADDR	dst;		/* destination address			*/
-	} __attribute__((packed, aligned(2)))T_TCP_IP4_Q_HDR;
-
-#ifdef SUPPORT_MIB
-
-/*
- *  SNMP の 管理情報ベース (MIB)
- */
-
-typedef struct t_ip_stats {
-	uint32_t	ipInReceives;
-	uint32_t	ipInHdrErrors;
-	uint32_t	ipInAddrErrors;
-/*	uint32_t	ipForwDatagrams;*/
-	uint32_t	ipInUnknownProtos;
-/*	uint32_t	ipInDiscards;*/
-	uint32_t	ipInDelivers;
-	uint32_t	ipOutRequests;
-	uint32_t	ipOutDiscards;
-/*	uint32_t	ipOutNoRoutes;*/
-
-#ifdef IP4_CFG_FRAGMENT
-
-	uint32_t	ipReasmReqds;
-	uint32_t	ipReasmOKs;
-	uint32_t	ipReasmFails;
-	uint32_t	ipFragOKs;
-	uint32_t	ipFragFails;
-	uint32_t	ipFragCreates;
-
-#else	/* of #ifdef IP4_CFG_FRAGMENT */
-
-	uint32_t	ipReasmReqds;
-/*	uint32_t	ipReasmOKs;*/
-	uint32_t	ipReasmFails;
-/*	uint32_t	ipFragOKs;*/
-/*	uint32_t	ipFragFails;*/
-/*	uint32_t	ipFragCreates;*/
-
-#endif	/* of #ifdef IP4_CFG_FRAGMENT */
-
-} T_IP_STATS;
-
-extern T_IP_STATS ip_stats;
-
-#endif	/* of #ifdef SUPPORT_MIB */
-
-/*
- *  関数
- */
-
-extern void ip_frag_timer (void);
-extern void ip_init (void);
-extern ER ip_remove_options (T_NET_BUF *nbuf);
-extern ER ip_output (T_NET_BUF *nbuf, TMO tmout);
+#endif	/* of #if defined(_IP6_CFG) */
 
 #endif	/* of #ifndef _IP_VAR_H_ */
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/tcp.cfg
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/tcp.cfg	(revision 321)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/tcp.cfg	(revision 331)
@@ -2,5 +2,5 @@
  *  TINET (TCP/IP Protocol Stack)
  * 
- *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
+ *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
  *                   Tomakomai National College of Technology, JAPAN
  *
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/tcp.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/tcp.h	(revision 321)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/tcp.h	(revision 331)
@@ -2,5 +2,5 @@
  *  TINET (TCP/IP Protocol Stack)
  * 
- *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
+ *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
  *                   Tomakomai National College of Technology, JAPAN
  *
Index: EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/tcp_fsm.h
===================================================================
--- EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/tcp_fsm.h	(revision 321)
+++ EcnlProtoTool/trunk/asp3_dcre/tinet/netinet/tcp_fsm.h	(revision 331)
@@ -2,5 +2,5 @@
  *  TINET (TCP/IP Protocol Stack)
  * 
- *  Copyright (C) 2001-2009 by Dep. of Computer Science and Engineering
+ *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
  *                   Tomakomai National College of Technology, JAPAN
  *
